#define MIN_STOPLOSS_POINT 10
#define MIN_TAKEPROFIT_POINT 10 
#define MAGIC 125242

extern string sNameExpert = "";
extern int nAccount =0;
extern double StopLoss = 0;
extern double TakeProfit = 0;
extern double TrailingStop = 0;
extern double dLots = 0.10; 
extern int nSlippage = 5;
extern bool lFlagUseHourTrade = True;
extern int nFromHourTrade = 0;
extern int nToHourTrade = 23;
extern bool lFlagUseSound = True;
extern string sSoundFileName = "alert.wav";
extern color colorOpenBuy = Blue;
extern color colorCloseBuy = Aqua;
extern color colorOpenSell = Red;
extern color colorCloseSell = Aqua;

#include <lot_lib.mqh>


int init()
  {
//----
   lotlib_PrevLots = 0.0;  lotlib_PrevProfit = 0.0;   
//----
   return(0);
  }

void deinit() {
   //Comment("");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   if (lFlagUseHourTrade){
      if (!(Hour()>=nFromHourTrade && Hour()<=nToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
      }
   }
   
   if(Bars < 100){
      Print("bars less than 100");
      return(0);
   }
   
   if (nAccount > 0 && nAccount != AccountNumber()){
      Comment("Trade on account :"+AccountNumber()+" FORBIDDEN!");
      return(0);
   }
   
   if((StopLoss > 0 && StopLoss < MIN_STOPLOSS_POINT) ||
      (StopLoss > 0 && StopLoss < MIN_STOPLOSS_POINT)){
      Print("StopLoss less than " + MIN_STOPLOSS_POINT);
      return(0);
   }
   if((TakeProfit > 0 && TakeProfit < MIN_TAKEPROFIT_POINT) ||
      (TakeProfit > 0 && TakeProfit < MIN_TAKEPROFIT_POINT)){
      Print("TakeProfit less than " + MIN_TAKEPROFIT_POINT);
      return(0);
   }


   if(AccountFreeMargin() < (1000*Lot())){
      Print("We have no money. Free Margin = " + AccountFreeMargin());
      return(0);
   }
   
    lotlib_OpenPriceLevel = Ask; //  Ask -      
    lotlib_StopLossLevel = Ask-StopLoss*Point; //  Ask-StopLoss*Point -     

   
   bool lFlagBuyOpen = false, lFlagSellOpen = false, lFlagBuyClose = false, lFlagSellClose = false;

//----   
   lFlagBuyOpen = (Ask==0);
//----   
   lFlagSellOpen = (Bid==0);
//----   
   lFlagBuyClose = (Bid==0);
//----   
   lFlagSellClose = (Ask==0);
//----   
   if (!ExistPositions()){
   
      lotlib_PrevLots = OrderLots();  lotlib_PrevProfit = OrderProfit();
   
      if (lFlagBuyOpen){
         OpenBuy();
         return(0);
      }

      if (lFlagSellOpen){
         OpenSell();
         return(0);
      }
   }
   if (ExistPositions()){
      if(OrderType()==OP_BUY){
         if (lFlagBuyClose){
            bool flagCloseBuy = OrderClose(OrderTicket(), OrderLots(), Bid, nSlippage, colorCloseBuy); 
            if (flagCloseBuy && lFlagUseSound) 
               PlaySound(sSoundFileName); 
            return(0);
         }
      }
      if(OrderType()==OP_SELL){
         if (lFlagSellClose){
            bool flagCloseSell = OrderClose(OrderTicket(), OrderLots(), Ask, nSlippage, colorCloseSell); 
            if (flagCloseSell && lFlagUseSound) 
               PlaySound(sSoundFileName); 
            return(0);
         }
      }
   }
   
   if (TrailingStop > 0 || TrailingStop > 0){
      
      for (int i=0; i<OrdersTotal(); i++) { 
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
            bool lMagic = true;
            if (MAGIC > 0 && OrderMagicNumber() != MAGIC)
               lMagic = false;
            
            if (OrderSymbol()==Symbol() && lMagic) { 
               if (OrderType()==OP_BUY && TrailingStop > 0) { 
                  if (Bid-OrderOpenPrice() > TrailingStop*Point) { 
                     if (OrderStopLoss()<Bid-TrailingStop*Point) 
                        ModifyStopLoss(Bid-TrailingStop*Point); 
                  } 
               } 
               if (OrderType()==OP_SELL) { 
                  if (OrderOpenPrice()-Ask>TrailingStop*Point) { 
                     if (OrderStopLoss()>Ask+TrailingStop*Point || OrderStopLoss()==0)  
                        ModifyStopLoss(Ask+TrailingStop*Point); 
                  } 
               } 
            } 
         } 
      } 
   }
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         bool lMagic = true;
         
         if (MAGIC > 0 && OrderMagicNumber() != MAGIC)
            lMagic = false;

			if (OrderSymbol()==Symbol() && lMagic) {
				return(True);
			}
		} 
	} 
	return(false);
}

void ModifyStopLoss(double ldStopLoss) { 
   bool lFlagModify = OrderModify(OrderTicket(), OrderOpenPrice(), ldStopLoss, OrderTakeProfit(), 0, CLR_NONE); 
   if (lFlagModify && lFlagUseSound) 
      PlaySound(sSoundFileName); 
} 

void OpenBuy() { 
   double dStopLoss = 0, dTakeProfit = 0;

   if (StopLoss > 0)
      dStopLoss = Bid-StopLoss*Point;
   
   if (TakeProfit > 0)
     dTakeProfit = Ask + TakeProfit * Point; 
 
   
   int numorder = OrderSend(Symbol(), OP_BUY, Lot(), Ask, nSlippage, dStopLoss, dTakeProfit, sNameExpert, MAGIC, 0, colorOpenBuy); 
   
   if (numorder > -1 && lFlagUseSound) 
      PlaySound(sSoundFileName);
} 

void OpenSell() { 
   double dStopLoss = 0, dTakeProfit = 0;
   
   if (StopLoss > 0)
      dStopLoss = Ask+StopLoss*Point;
   
   if (TakeProfit > 0)
      dTakeProfit = Bid-TakeProfit*Point;
   
   int numorder = OrderSend(Symbol(),OP_SELL, Lot(), Bid, nSlippage, dStopLoss, dTakeProfit, sNameExpert, MAGIC, 0, colorOpenSell); 
   
   if (numorder > -1 && lFlagUseSound) 
      PlaySound(sSoundFileName); 
} 

